''===========================================================
''  
''  CreateBackup
''  
''  Author      :hillbasesoft
''  Version     :01.04
''  Created     :01.00   2012/07/25
''  Modified    :01.04   2018/07/25
''              :
''  Copyright 2012-2018 hillbasesoft All Rights Reserved.
''===========================================================

Option Explicit

Const cProgramName   = "CreateBackup"                  'vO
Const cMajorVersion  = "01"                            'W[o[W
Const cMinorVersion  = "04"                            '}Ci[o[W
Const cAuthor        = "hillbasesoft"                  '
Const cCopyrightTerm = "2012-2018"                     '쌠
Const cLastUpdate    = "2018/07/25"                    'ŏIXV

Dim dbFlg :dbFlg     = False                           'fobOtO




''***********************************************************
'' 
'' ʊ֐
'' 
''***********************************************************


''===========================================================
''  name        : StdOutHelp
''  description : wvpbZ[W\
''  param       : 
''===========================================================
Sub MsgHelp()
    Dim MSG
    MSG = MSG &             "Usage: CreateBackup.vbs [-options] [file path for copyfrom] [file path for copyto]"
    MSG = MSG & vbNewLine & ""
    MSG = MSG & vbNewLine & "where options include:"
    MSG = MSG & vbNewLine & "    -version      print product version and exit"
    MSG = MSG & vbNewLine & "    -help         print this help message"
    MSG = MSG & vbNewLine & ""
    MsgBox MSG, vbInformation, "Help"
End Sub


''===========================================================
''  name        : MsgBoxCopyright
''  description : Rs[CgpbZ[W\
''  param       : 
''===========================================================
Sub MsgBoxCopyright()
    Dim MSG
    MSG = MSG &             cProgramName
    MSG = MSG & vbNewLine & ""
    MSG = MSG & vbNewLine & "Version : " & cMajorVersion & "." & cMinorVersion
    MSG = MSG & vbNewLine & "Last Updated : " & cLastUpdate
    MSG = MSG & vbNewLine & ""
    MSG = MSG & vbNewLine &"Copyright  " & cCopyrightTerm & " " & cAuthor & " All Rights Reserved."
    MSG = MSG & vbNewLine & ""
    MsgBox MSG, vbInformation, "Copyright"
End Sub 


''===========================================================
''  name        : MsgBoxStopProcess
''  description : ̓f[^`FbÑbZ[W{bNX\
''  param       : MSG           in      bZ[W
''===========================================================
Sub MsgBoxStopProcess(MSG)
    MSG = "Stop process." & _
          vbNewLine            & _
          vbNewLine            & _
          "ReasonF" & MSG
    MsgBox MSG, vbCritical + vbOKOnly, "Check Input Data"
End Sub 


''===========================================================
''  name        : MsgBoxInformation
''  description : bZ[W{bNX\
''  param       : MSG           in      bZ[W
''              : TITLE         in      ^Cg
''===========================================================
Sub MsgBoxInformation(MSG, TITLE)
    MsgBox MSG, vbInformation, TITLE
End Sub 


''===========================================================
''  name        : MsgBoxCheckInputData
''  description : ̓f[^`FbÑbZ[W{bNX\
''  param       : MSG           in      bZ[W
''===========================================================
Sub MsgBoxCheckInputData(MSG)
    MsgBox MSG, vbCritical + vbOKOnly, "Check Input Data"
End Sub 


''===========================================================
''  name        : MsgBoxError
''  description : G[̃bZ[W{bNX\
''  param       : MSG           in      bZ[W
''===========================================================
Sub MsgBoxError(MSG)
    MsgBox MSG, vbCritical + vbOKOnly, "Error"
End Sub 


''===========================================================
''  name        : MsgBoxQuestion
''  description : mF̃bZ[W{bNX\
''  param       : MSG           in      bZ[W
''===========================================================
Function MsgBoxQuestion(MSG)
     MsgBoxQuestion = MsgBox(MSG, vbYesNo + vbDefaultButton2 + vbQuestion, "")
End Function


''===========================================================
''  name        : MsgBoxSuccess
''  description : ̃bZ[W\
''===========================================================
Sub MsgBoxSuccess()
    MsgBox "Backup completed.", vbInformation, "Success"
End Sub 


''===========================================================
''  name        : MsgBoxFault
''  description : s̃bZ[W\
''===========================================================
Sub MsgBoxFault()
    MsgBox "Backup is fault." & vbNewLine & "The detail is referring to log file.", vbCritical + vbOKOnly, "Fault"
End Sub 


''===========================================================
''  name        : MsgBoxInput
''  description : ͎̃bZ[W{bNX\
''  param       : MSG           in      bZ[W
''===========================================================
Function MsgBoxInput(MSG)
    MsgBoxInput = InputBox("Input the name of files or folders.", "", MSG)
End Function 


''===========================================================
''  name        : Debugln
''  description : fobOpbZ[W\
''  param       : MSG           in      bZ[W
''===========================================================
Sub Debugln(MSG)
    If dbFlg = False Then
        Exit Sub
    End If
    MsgBox MSG, vbInformation, "Debug Info"
End Sub 


''===========================================================
''  name        : IsExistFile
''  description : t@C̑ݗL𔻒肷
''  param       : path          in      ΃pX
''  return      : True                  ݂
''              : False                 ݂Ȃ
''===========================================================
Function IsExistFile(path)
    
    Dim FSO
    Set FSO = CreateObject("Scripting.FileSystemObject")
    IsExistFile = FSO.FileExists(path)
    Set FSO = Nothing
    
End Function


''===========================================================
''  name        : IsExistFolder
''  description : tH_̑ݗL𔻒肷
''  param       : path          in      ΃pX
''  return      : True                  ݂
''              : False                 ݂Ȃ
''===========================================================
Function IsExistFolder(path)
    
    Dim FSO
    Set FSO = CreateObject("Scripting.FileSystemObject")
    IsExistFolder = FSO.FolderExists(path)
    Set FSO = Nothing
    
End Function




''***********************************************************
'' 
'' INIt@CNX
'' 
''***********************************************************

Class IniFileInfo
    
    
    '------------------------------------------
    '  vpeB
    '------------------------------------------
    Private m_iniFileFolderPath               'INIt@C̃tH_pX
    Private m_iniFileName                     'INIt@C̖O
    Private m_iniFilePath                     'INIt@C̐΃pX
    
    Private m_showFolderDialog                'vpeB ShowFolderDialog
    Private m_showFileNameDialog              'vpeB ShowFileNameDialog
    Private m_showMessageSuccess              'vpeB ShowMessageSuccess
    Private m_createZip                       'vpeB CreateZip
    Private m_showMessageCreateZip            'vpeB ShowMessageCreateZip
    Private m_outputLog                       'vpeB OutputLog
    Private m_logFolderPath                   'vpeB LogFolderPath
    Private m_debugFlag                       'vpeB DebugFlag
    Private m_inputInfoFilePath               'vpeB InputInfoFilePath
    Private m_outputFolderPath                'vpeB OutputFolderPath
    Private m_copyOptionFile                  'vpeB CopyOptionFile
    Private m_xcopyOptionFolder               'vpeB XCopyOptionFolder
    Private m_shellRunIntWindowTypeCopyFile   'vpeB ShellRunWindowTypeCopyFile
    Private m_shellRunIntWindowTypeCopyFolder 'vpeB ShellRunWindowTypeCopyFolder
    Private m_format                          'vpeB Format
    Private m_positionBeforeExtension         'vpeB PositionBeforeExtension
    
    Private m_inputFilePathList()             'vpeB InputInfoFilePathŎw肳ꂽt@C擾΃pX̔z
    
    '------------------------------------------
    '  RXgN^
    '------------------------------------------
    Private Sub Class_Initialize()
        
        m_iniFileFolderPath                = Left(WScript.ScriptFullName, Len(WScript.ScriptFullName) - Len(WScript.ScriptName) )
        m_iniFileName                      = "CreateBackup.ini"
        m_iniFilePath                      = m_iniFileFolderPath & m_iniFileName
        
        m_showFolderDialog                 = False
        m_showFileNameDialog               = False
        m_showMessageSuccess               = True
        m_createZip                        = False
        m_showMessageCreateZip             = False
        m_outputLog                        = True
        m_logFolderPath                    = m_iniFileFolderPath & "Log"
        m_debugFlag                        = False
        m_inputInfoFilePath                = ""
        m_outputFolderPath                 = ""
        m_copyOptionFile                   = "/Y /V"
        m_xcopyOptionFolder                = "/Y /K /R /H /E /V /I"
        m_shellRunIntWindowTypeCopyFile    = 0
        m_shellRunIntWindowTypeCopyFolder  = 0
        m_format                           = "YYYYMMDD_HHMISS"
        m_positionBeforeExtension          = False
        
        ReDim Preserve m_inputFilePathList(0)
        
    End Sub
    
    
    '------------------------------------------
    '  fRXgN^
    '------------------------------------------
    Private Sub Class_Terminate()
        
    End Sub
    
    
    '------------------------------------------
    '  Getn֐
    '------------------------------------------
    Public Property Get ShowFolderDialog                  :ShowFolderDialog                 = m_showFolderDialog                  :End Property
    Public Property Get ShowFileNameDialog                :ShowFileNameDialog               = m_showFileNameDialog                :End Property
    Public Property Get ShowMessageSuccess                :ShowMessageSuccess               = m_showMessageSuccess                :End Property
    Public Property Get CreateZip                         :CreateZip                        = m_createZip                         :End Property
    Public Property Get ShowMessageCreateZip              :ShowMessageCreateZip             = m_showMessageCreateZip              :End Property
    Public Property Get OutputLog                         :OutputLog                        = m_outputLog                         :End Property
    Public Property Get LogFolderPath                     :LogFolderPath                    = m_logFolderPath                     :End Property
    Public Property Get DebugFlag                         :DebugFlag                        = m_debugFlag                         :End Property
    Public Property Get InputInfoFilePath                 :InputInfoFilePath                = m_inputInfoFilePath                 :End Property
    Public Property Get OutputFolderPath                  :OutputFolderPath                 = m_outputFolderPath                  :End Property
    Public Property Get CopyOptionFile                    :CopyOptionFile                   = m_copyOptionFile                    :End Property
    Public Property Get XcopyOptionFolder                 :XcopyOptionFolder                = m_xcopyOptionFolder                 :End Property
    Public Property Get ShellRunIntWindowTypeCopyFile     :ShellRunIntWindowTypeCopyFile    = m_shellRunIntWindowTypeCopyFile     :End Property
    Public Property Get ShellRunIntWindowTypeCopyFolder   :ShellRunIntWindowTypeCopyFolder  = m_shellRunIntWindowTypeCopyFolder   :End Property
    Public Property Get InputFilePathList                 :InputFilePathList                = m_inputFilePathList                 :End Property
    Public Property Get Format                            :Format                           = m_format                            :End Property
    Public Property Get PositionBeforeExtension           :PositionBeforeExtension          = m_positionBeforeExtension           :End Property
    
    
    '------------------------------------------
    '  Letn֐
    '------------------------------------------
    'Letn֐Ȃ
    
    
    ''===========================================================
    ''  name        : Read
    ''  description : INIt@Cǂݍ
    ''  param       : MSG           in      bZ[W
    ''===========================================================
    Public Function Read(EMSG)
        
        Read = False
        
        '------------------------------
        ' INIt@C̑݃`FbN
        '------------------------------
        If IsExistFile(m_iniFilePath) = False Then
            Call CreateIniFile
        End If
        
        
        '------------------------------
        ' t@C̃I[v
        '------------------------------
        Dim fs
        Set fs = WScript.CreateObject("Scripting.FileSystemObject")
        
        Dim f
        Set f = fs.OpenTextFile(m_iniFilePath)
        
        
        '------------------------------
        ' sPʂ̓ǂݍ
        '------------------------------
        Do While f.AtEndOfStream <> True
            
            Dim s
            s = Trim(f.ReadLine)
            
            If Len(s) > 0 And StrComp("#", Left(s, 1)) <> 0 Then
                
                Dim ary
                ary = Split(s,"=")
                
                Dim pName      :pName  = Trim(ary(0))     'vpeB
                Dim pValue     :pValue = Trim(ary(1))     'ݒl
                
                '------------------------------
                ' vpeBl̐ݒ
                '------------------------------
                Select Case pName
                
                Case "SHOW_FOLDER_DIALOG"
                    
                    If StrComp("TRUE", UCASE(pValue)) = 0 Or StrComp("FALSE", UCASE(pValue)) = 0 Then
                        m_showFolderDialog = CBool(pValue)
                    End If
                    
                    
                Case "SHOW_FILE_NAME_DIALOG"
                    
                    If StrComp("TRUE", UCASE(pValue)) = 0 Or StrComp("FALSE", UCASE(pValue)) = 0 Then
                        m_showFileNameDialog = CBool(pValue)
                    End If
                    
                    
                Case "SHOW_MESSAGE_SUCCESS"
                    
                    If StrComp("TRUE", UCASE(pValue)) = 0 Or StrComp("FALSE", UCASE(pValue)) = 0 Then
                        m_showMessageSuccess = CBool(pValue)
                    End If
                    
                    
                Case "CREATE_ZIP"
                    
                    If StrComp("TRUE", UCASE(pValue)) = 0 Or StrComp("FALSE", UCASE(pValue)) = 0 Then
                        m_createZip = CBool(pValue)
                    End If
                    
                    
                Case "SHOW_MESSAGE_CREATE_ZIP"
                    
                    If StrComp("TRUE", UCASE(pValue)) = 0 Or StrComp("FALSE", UCASE(pValue)) = 0 Then
                        m_showMessageCreateZip = CBool(pValue)
                    End If
                    
                    
                Case "OUTPUT_LOG"
                    
                    If StrComp("TRUE", UCASE(pValue)) = 0 Or StrComp("FALSE", UCASE(pValue)) = 0 Then
                        m_outputLog = CBool(pValue)
                    End If
                    
                    
                Case "LOG_FOLDER_PATH"
                    
                    If m_outputLog And IsExistFolder(pValue) Then
                        m_logFolderPath = pValue
                    End If
                    
                    
                Case "DEBUG_FLAG"
                    
                    If StrComp("TRUE", UCASE(pValue)) = 0 Or StrComp("FALSE", UCASE(pValue)) = 0 Then
                        m_debugFlag = CBool(pValue)
                    End If
                    
                    
                Case "INPUT_INFO_FILE_PATH"
                    
                    If IsExistFile(pValue) Or IsExistFolder(pValue) Then
                        m_inputInfoFilePath = pValue
                    End If
                    
                    
                Case "OUTPUT_FOLDER_PATH"
                    
                    If IsExistFolder(pValue) Then
                        m_outputFolderPath = pValue
                    End If
                    
                    
                 Case "COPY_OPTION_FILE"
                    
                    If Len(Trim(pValue)) >= 2 Then
                        m_copyOptionFile = pValue
                    End If
                    
                    
                 Case "XCOPY_OPTION_FOLDER"
                    
                    If Len(Trim(pValue)) >=2 Then
                        m_xcopyOptionFolder = pValue
                    End If
                    
                    
                 Case "SHELL_RUN_INT_WINDOW_TYPE_COPY_FILE"
                    
                    If IsNumeric(pValue) Then
                        m_shellRunIntWindowTypeCopyFile = CInt(pValue)
                    End If
                    
                    
                 Case "SHELL_RUN_INT_WINDOW_TYPE_COPY_FOLDER"
                    
                    If IsNumeric(pValue) Then
                        m_shellRunIntWindowTypeCopyFolder = CInt(pValue)
                    End If
                    
                    
                 Case "FORMAT"
                    
                    If Len(Trim(pValue)) > 0 Then
                       
                       If InStr(pValue,"\")  <> 0 Or _
                          InStr(pValue,"/")  <> 0 Or _
                          InStr(pValue,";")  <> 0 Or _
                          InStr(pValue,"*")  <> 0 Or _
                          InStr(pValue,"?")  <> 0 Or _
                          InStr(pValue,"""") <> 0 Or _
                          InStr(pValue,"<")  <> 0 Or _
                          InStr(pValue,">")  <> 0 Or _
                          InStr(pValue,"|")  <> 0 Then
                          
                          'EMSG = "INIt@CFormatvpeBɎ͎̕gpł܂B" & _
                          EMSG = "It can not use the following characters as Format property." & _
                                 vbNewLine & _
                                 "\ / ; * ? " & """" & "< > |"
                          f.Close
                          
                          Set f  = Nothing
                          Set fs = Nothing
                          
                          Exit Function
                          
                       End If
                       
                       m_format = CStr(pValue)
                       
                    End If
                    
                    
                Case "POSITION_BEFORE_EXTENSION"
                    
                    If StrComp("TRUE", UCASE(pValue)) = 0 Or StrComp("FALSE", UCASE(pValue)) = 0 Then
                        m_positionBeforeExtension = CBool(pValue)
                    End If
                    
                    
                End Select
                
                
            End If
        Loop
        
        '------------------------------
        ' t@C̃N[Y
        '------------------------------
        f.Close
        
        Set f  = Nothing
        Set fs = Nothing
        
        Read = True
        
    End Function
    
    
    ''===========================================================
    ''  name        : CreateIniFile
    ''  description : INIt@C𐶐
    ''===========================================================
    Private Sub CreateIniFile()
        
        Dim s
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# SHOW_FOLDER_DIALOG vpeB"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <EN>"
        s = s & vbNewLine & "# This property is to show the folder selection dialog."
        s = s & vbNewLine & "# True is to show this dialog."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# True  :Available"
        s = s & vbNewLine & "# False :Unavailable"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <JP>"
        s = s & vbNewLine & "# ̃vpeB̓tH_Iʂ̕\E\ݒ肵܂."
        s = s & vbNewLine & "# ̃vpeBLȏꍇ, tH_Iʂ\܂."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# True  :L"
        s = s & vbNewLine & "# False :"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "SHOW_FOLDER_DIALOG=" & m_showFolderDialog
        s = s & vbNewLine & ""
        s = s & vbNewLine & ""
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# SHOW_FILE_NAME_DIALOG vpeB"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <EN>"
        s = s & vbNewLine & "# This property is to show the input file name dialog."
        s = s & vbNewLine & "# True is to show this dialog."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# True  :Available"
        s = s & vbNewLine & "# False :Unavailable"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <JP>"
        s = s & vbNewLine & "# ̃vpeB̓t@C̓_CAO̕\E\ݒ肵܂."
        s = s & vbNewLine & "# ̃vpeBLȏꍇ, t@C̓_CAO\܂."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# True  :L"
        s = s & vbNewLine & "# False :"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "SHOW_FILE_NAME_DIALOG=" & m_showFileNameDialog
        s = s & vbNewLine & ""
        s = s & vbNewLine & ""
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# SHOW_MESSAGE_SUCCESS vpeB"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <EN>"
        s = s & vbNewLine & "# This property is to show the success message."
        s = s & vbNewLine & "# True is to show this message after backup process completed."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# True  :Available"
        s = s & vbNewLine & "# False :Unavailable"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <JP>"
        s = s & vbNewLine & "# ̃vpeB͊bZ[W̕\E\ݒ肵܂."
        s = s & vbNewLine & "# ̃vpeBLȏꍇ, obNAbv, bZ[W\܂."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# True  :L"
        s = s & vbNewLine & "# False :"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "SHOW_MESSAGE_SUCCESS=" & m_showMessageSuccess
        s = s & vbNewLine & ""
        s = s & vbNewLine & ""
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# CREATE_ZIP vpeB"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <EN>"
        s = s & vbNewLine & "# This property is to create ZIP file."
        s = s & vbNewLine & "# True is to create ZIP file as a backup file."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# True  :Available"
        s = s & vbNewLine & "# False :Unavailable"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <JP>"
        s = s & vbNewLine & "# ̃vpeBZipt@C𐶐܂."
        s = s & vbNewLine & "# ̃vpeBLȏꍇ, obNAbvt@CZipt@CƂďo͂܂."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# True  :L"
        s = s & vbNewLine & "# False :"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "CREATE_ZIP=" & m_createZip
        s = s & vbNewLine & ""
        s = s & vbNewLine & ""
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# SHOW_MESSAGE_CREATE_ZIP vpeB"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <EN>"
        s = s & vbNewLine & "# This property is to show the message when it confirms to create ZIP file."
        s = s & vbNewLine & "# It is avaialble when CREATE_ZIP property is True."
        s = s & vbNewLine & "# It creates ZIP file when you click Yes button."
        s = s & vbNewLine & "# It does not create ZIP file when you click No button."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# True  :Available"
        s = s & vbNewLine & "# False :Unavailable"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <JP>"
        s = s & vbNewLine & "# ̃vpeBZipt@CmFbZ[W\܂."
        s = s & vbNewLine & "# CREATE_ZIPvpeBLȏꍇɗpł܂."
        s = s & vbNewLine & "# u͂v{^NbN, Zipt@C𐶐܂."
        s = s & vbNewLine & "# uv{^NbN, obNAbvt@C܂̓tH_𐶐܂."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# True  :L"
        s = s & vbNewLine & "# False :"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "SHOW_MESSAGE_CREATE_ZIP=" & m_showMessageCreateZip
        s = s & vbNewLine & ""
        s = s & vbNewLine & ""
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# OUTPUT_LOG vpeB"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <EN>"
        s = s & vbNewLine & "# This property is to output log file."
        s = s & vbNewLine & "# True is to output log file."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# True  :Available"
        s = s & vbNewLine & "# False :Unavailable"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <JP>"
        s = s & vbNewLine & "# ̃vpeB̓Ȍo͂ݒ肵܂."
        s = s & vbNewLine & "# ̃vpeBLȏꍇ, Oo͂܂."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# True  :L"
        s = s & vbNewLine & "# False :"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "OUTPUT_LOG=" & m_outputLog
        s = s & vbNewLine & ""
        s = s & vbNewLine & ""
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# LOG_FOLDER_PATH vpeB"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <EN>"
        s = s & vbNewLine & "# This property is to define log folder path."
        s = s & vbNewLine & "# True is available when OUTPUT_LOG property is True."
        s = s & vbNewLine & "# Default is log folder in installed folder."
        s = s & vbNewLine & "# It outputs log file to default folder when this property path is nothing."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <JP>"
        s = s & vbNewLine & "# ̃vpeB̓Ot@C̏o͐tH_ݒ肵܂."
        s = s & vbNewLine & "# OUTPUT_LOGvpeBLȏꍇɗpł܂."
        s = s & vbNewLine & "# ftHg̓CXg[tH_LogtH_ł."
        s = s & vbNewLine & "# ݒl݂ȂtH_̏ꍇ, ftHg̃tH_ݒ肵܂."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "LOG_FOLDER_PATH=" & m_logFolderPath
        s = s & vbNewLine & ""
        s = s & vbNewLine & ""
        'Add v1.03
        If dbFlg Then
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# DEBUG_FLAG vpeB"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# ̃vpeB̓Oo͎ɃfobObZ[W̏o͂ݒ肵܂."
        s = s & vbNewLine & "# ̃vpeBLȏꍇ, fobObZ[WO֏o͂܂."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# True  :o͂"
        s = s & vbNewLine & "# False :o͂Ȃ"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "DEBUG_FLAG=" & m_debugFlag
        s = s & vbNewLine & ""
        s = s & vbNewLine & ""
        End If
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# INPUT_INFO_FILE_PATH vpeB"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <EN>"
        s = s & vbNewLine & "# This property is set the absolute path of the input file information."
        s = s & vbNewLine & "# The input file information is backup object of files and folders."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <JP>"
        s = s & vbNewLine & "# ̃vpeB͓̓t@C̃t@Cݒ肵܂."
        s = s & vbNewLine & "# ̓t@Cɂ̓obNAbvΏۂƂȂt@C܂̓tH_̐΃pXL܂."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "INPUT_INFO_FILE_PATH=" & m_inputInfoFilePath
        s = s & vbNewLine & ""
        s = s & vbNewLine & ""
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# OUTPUT_FOLDER_PATH vpeB"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <EN>"
        s = s & vbNewLine & "# This property is set the absolute path of output folder."
        s = s & vbNewLine & "# Default is same folder where the backup files or folders are deployed."
        s = s & vbNewLine & "# It is default if value is empty."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <JP>"
        s = s & vbNewLine & "# ̃vpeB̓obNAbv̏o͐tH_w肵܂."
        s = s & vbNewLine & "# ftHg̓obNAbvΏۂƂȂt@C܂̓tH_zutH_ł."
        s = s & vbNewLine & "# ݒl݂ȂtH_̏ꍇ, ftHg̃tH_ݒ肵܂."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "OUTPUT_FOLDER_PATH=" & m_outputFolderPath
        s = s & vbNewLine & ""
        s = s & vbNewLine & ""
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# COPY_OPTION_FILE vpeB"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <EN>"
        s = s & vbNewLine & "# This property is the option for copying files."
        s = s & vbNewLine & "# It is used by COPY command. Default is /Y /E."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <JP>"
        s = s & vbNewLine & "# ̃vpeB̓t@CRs[Ƃ̃IvVw肵܂."
        s = s & vbNewLine & "# COPYR}hgp܂. ftHg /Y /E ł."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "COPY_OPTION_FILE=" & m_copyOptionFile
        s = s & vbNewLine & ""
        s = s & vbNewLine & ""
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# XCOPY_OPTION_FOLDER vpeB"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <EN>"
        s = s & vbNewLine & "# This property is the option for copying folders."
        s = s & vbNewLine & "# It is used by XCOPY command. Default is /Y /K /R /H /E /V /I."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <JP>"
        s = s & vbNewLine & "# ̃vpeB̓tH_Rs[Ƃ̃IvVw肵܂."
        s = s & vbNewLine & "# XCOPYR}hgp܂. ftHg /Y /K /R /H /E /V /I ł."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "XCOPY_OPTION_FOLDER=" & m_xcopyOptionFolder
        s = s & vbNewLine & ""
        s = s & vbNewLine & ""
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# SHELL_RUN_INT_WINDOW_TYPE_COPY_FILE vpeB"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <EN>"
        s = s & vbNewLine & "# This property is to set the DOS window layout when it copies files."
        s = s & vbNewLine & "# It is used by copying files when it creates new process."
        s = s & vbNewLine & "# Default is 0."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <JP>"
        s = s & vbNewLine & "# ̃vpeB̓t@CRs[̃vÕEBhE̊Oςlw肵܂."
        s = s & vbNewLine & "# VvZXCOPYR}hsƂɃEBhE̊Oςw肵܂. ftHg 0 ł."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "SHELL_RUN_INT_WINDOW_TYPE_COPY_FILE=" & m_shellRunIntWindowTypeCopyFile
        s = s & vbNewLine & ""
        s = s & vbNewLine & ""
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# SHELL_RUN_INT_WINDOW_TYPE_COPY_FOLDER vpeB"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <EN>"
        s = s & vbNewLine & "# This property is to set the DOS window layout when it copies folders."
        s = s & vbNewLine & "# It is used by copying folders when it creates new process."
        s = s & vbNewLine & "# Default is 0."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <JP>"
        s = s & vbNewLine & "# ̃vpeB̓tH_Rs[̃vÕEBhE̊Oςlw肵܂."
        s = s & vbNewLine & "# VvZXXCOPYR}hsƂɃEBhE̊Oςw肵܂. ftHg 0 ł."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "SHELL_RUN_INT_WINDOW_TYPE_COPY_FOLDER=" & m_shellRunIntWindowTypeCopyFolder
        s = s & vbNewLine & ""
        s = s & vbNewLine & ""
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# FORMAT vpeB"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <EN>"
        s = s & vbNewLine & "# This property is to set the attaching format of file and folder name."
        s = s & vbNewLine & "# Default format is " & m_format & " if this is empty."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# YYYY   :Year(the four digits)"
        s = s & vbNewLine & "# YY     :Year(the two  digits)"
        s = s & vbNewLine & "# MM     :Month"
        s = s & vbNewLine & "# DD     :Day"
        s = s & vbNewLine & "# HH     :Hour"
        s = s & vbNewLine & "# MI     :Minute"
        s = s & vbNewLine & "# SS     :Second"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <JP>"
        s = s & vbNewLine & "# ̃vpeB̓t@C/tH_̖OɎt镶̃tH[}bgݒ肵܂."
        s = s & vbNewLine & "# ̃vpeB̏ꍇ, tH[}bg̓ftHg(" & m_format & ")ݒ肵܂."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# YYYY   :N(4)"
        s = s & vbNewLine & "# YY     :N(2)"
        s = s & vbNewLine & "# MM     :"
        s = s & vbNewLine & "# DD     :"
        s = s & vbNewLine & "# HH     :"
        s = s & vbNewLine & "# MI     :"
        s = s & vbNewLine & "# SS     :b"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "FORMAT=" & m_format
        s = s & vbNewLine & ""
        s = s & vbNewLine & ""
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# POSITION_BEFORE_EXTENSION vpeB"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <EN>"
        s = s & vbNewLine & "# This property is to insert system date and time before file extension."
        s = s & vbNewLine & "# It is applied if this property is True and backup object is file."
        s = s & vbNewLine & "# Default is False."
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# True  :Available"
        s = s & vbNewLine & "# False :Unavailable"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# <JP>"
        s = s & vbNewLine & "# ̃vpeB̓VXegq̑Oɑ}܂."
        s = s & vbNewLine & "# ̃vpeBLt@C̏ꍇɓKp܂."
        s = s & vbNewLine & "# ftHg͖łB"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "# True  :L"
        s = s & vbNewLine & "# False :"
        s = s & vbNewLine & "# "
        s = s & vbNewLine & "#========================================================="
        s = s & vbNewLine & "POSITION_BEFORE_EXTENSION=" & m_positionBeforeExtension
        s = s & vbNewLine & ""
        s = s & vbNewLine & ""
        
        Const ForReading    = 1
        Const ForWriting    = 2
        Const ForAppending  = 8
        
        Dim fso :Set fso = WScript.CreateObject("Scripting.FileSystemObject")
        Dim f   :Set f   = fso.OpenTextFile(m_iniFilePath, ForWriting, True)
        
        f.Write(s)
        f.Close
        
        Set f   = Nothing
        Set fso = Nothing
        
        
    End Sub
    
    
End Class




''***********************************************************
'' 
'' ONX
'' 
''***********************************************************

Class Log2
    
    
    '------------------------------------------
    '  vpeB
    '------------------------------------------
    Private m_logFso                          't@CVXẽIuWFNg
    Private m_logFile                         't@C̃IuWFNg
    
    Private m_logFolderPath                   'Ot@C̃tH_pX
    Private m_logFileName                     'Ot@C̖O
    Private m_logFilePath                     'Ot@C̐΃pX
    Private m_outputLog                       'Oo̓tO
    Private m_debugFlag                       'fobOtO
    
    
    '------------------------------------------
    '  RXgN^
    '------------------------------------------
    Private Sub Class_Initialize()
        
        Set m_logFso         = Nothing
        Set m_logFile        = Nothing
        m_logFolderPath      = Left(WScript.ScriptFullName, Len(WScript.ScriptFullName) - Len(WScript.ScriptName) ) & "Log"
        m_logFileName        = "Log" & GetYYYYMMDD() & ".log"
        m_logFilePath        = m_logFolderPath & "\" & m_logFileName
        m_outputLog          = False
        m_debugFlag          = False
        
    End Sub
    
    
    '------------------------------------------
    '  fRXgN^
    '------------------------------------------
    Private Sub Class_Terminate()
        
        Set m_logFso    = Nothing
        Set m_logFile   = Nothing
        
    End Sub
    
    
    '------------------------------------------
    '  Getn֐
    '------------------------------------------
    Public Property Get LogFolderPath        :LogFolderPath     = m_logFolderPath    :End Property
    Public Property Get LogFileName          :LogFileName       = m_logFileName      :End Property
    Public Property Get LogFilePath          :LogFilePath       = m_logFilePath      :End Property
    Public Property Get OutputLog            :OutputLog         = m_outputLog        :End Property
    Public Property Get DebugFlag            :DebugFlag         = m_debugFlag        :End Property
    
    
    '------------------------------------------
    '  Letn֐
    '------------------------------------------
    Public Property Let LogFilePath(value)
        
        '݃`FbN
        If isExistFile(value) = False Then
            Exit Property
        End If
        
        m_logFilePath    = value                                               'Ot@C̐΃pX
        m_logFileName    = Mid(value, InstrRev(value, "\") + 1, Len(value))    'Ot@C̖O
        m_logFolderPath  = Mid(value, 1, InstrRev(value, "\") - 1)             'Ot@C̃tH_pX
        
        
    End Property
    
    Public Property Let LogFileName(value)
        m_logFileName = value                                   'Ot@C̖O
        m_logFilePath = m_logFolderPath & "\" & m_logFileName   'Ot@C̃tH_pX
    End Property
    
    Public Property Let LogFolderPath(value)
        
        '݃`FbN
        If IsExistFolder(value) = False Then
            Exit Property
        End If
        
        
        'Ot@C̃tH_pX
        If Len(value) = InstrRev(value, "\") Then
            m_logFolderPath  = Mid(value, 1, InstrRev(value, "\") - 1)
        Else
            m_logFolderPath  = value
        End If
        
        'Ot@C̐΃pX
        m_logFilePath = m_logFolderPath & "\" & m_logFileName
        
    End Property
    
    Public Property Let OutputLog(value)     :m_outputLog    = value           :End Property
    Public Property Let DebugFlag(value)     :m_debugFlag    = value           :End Property
    
    
    
    
    ''===========================================================
    ''  name        : GetYYMMDD
    ''  description : t̕(YYYYMMDD)Ԃ
    ''  
    ''===========================================================
    Private Function GetYYYYMMDD()
        
        Dim tm    :tm   = now()
        
        Dim YYYY  :YYYY = Year(tm)
        Dim MM    :MM   = Right("0" & Month(tm) , 2)
        Dim DD    :DD   = Right("0" & Day(tm)   , 2)
        
        GetYYYYMMDD = YYYY & MM & DD
        
    End Function
    
    
    ''===========================================================
    ''  name        : Open
    ''  description : I[v
    ''  param       : 
    ''===========================================================
    Public Sub Open()
        
        If m_outputLog = False Then
            Exit Sub
        End If
        
        Call CreateFolder(m_logFolderPath)
        
        Const ForReading   = 1
        Const ForWrite     = 2
        Const ForAppending = 8
        Set m_logFso  = WScript.CreateObject("Scripting.FileSystemObject")
        Set m_logFile = m_logFso.OpenTextFile(m_logFilePath, ForAppending, True)
        
        
    End Sub
    
    
    ''===========================================================
    ''  name        : CreateFolder
    ''  description : tH_𐶐
    ''  param       : folderPath    in      tH_̐΃pX
    ''===========================================================
    Private Sub CreateFolder(folderPath)
        Dim fso
        Set fso = CreateObject("Scripting.FileSystemObject")
        If  fso.FolderExists(folderPath) = False Then
            fso.CreateFolder(folderPath)
        End IF
        Set fso = Nothing
    End Sub
    
    
    ''===========================================================
    ''  name        : Close
    ''  description : N[Y
    ''===========================================================
    Public Sub Close()
        If m_outputLog = False Then :Exit Sub  :End If
        m_logFile.Close
        Set m_logFile = Nothing
        Set m_logFso  = Nothing
    End Sub
    
    
    ''===========================================================
    ''  name        : Write
    ''  description : Oo͂B
    ''  param       : MSG           in      bZ[W
    ''===========================================================
    Private Sub Write(MSG)
        m_logFile.Write(MSG)
    End Sub
    
    ''===========================================================
    ''  name        : Debug
    ''  description : fobOpOo͂B
    ''  param       : MSG           in      bZ[W
    ''===========================================================
    Public Sub Debug(MSG)
        If m_outputLog = False Then :Exit Sub  :End If
        If m_debugFlag = False Then :Exit Sub  :End If
        Call Write(MSG)
    End Sub
    
    
    ''===========================================================
    ''  name        : Debugln
    ''  description : Oo͂(s)B
    ''  param       : MSG           in      bZ[W
    ''===========================================================
    Public Sub Debugln(MSG)
        Call Debug(MSG & vbNewLine)
    End Sub
    
    
    ''===========================================================
    ''  name        : Print
    ''  description : fobOpOo͂B
    ''  param       : MSG           in      bZ[W
    ''===========================================================
    Public Sub Print(MSG)
        If m_outputLog = False Then :Exit Sub  :End If
        Call Write(MSG)
    End Sub
    
    
    ''===========================================================
    ''  name        : Println
    ''  description : Oo͂(s)B
    ''  param       : MSG           in      bZ[W
    ''===========================================================
    Public Sub Println(MSG)
        Call Print(MSG & vbNewLine)
    End Sub
    
    
    ''===========================================================
    ''  name        : PrintHeader
    ''  description : wb_[Oo͂
    ''===========================================================
    Public Sub PrintHeader()
        Call Println("--------------------------------------------------------------------------------------------------------")
        'Call Println("Jn :" & now())
        Call Println("Start Date :" & now())
    End Sub 
    
    
    ''===========================================================
    ''  name        : PrintFooter
    ''  description : tb^[Oo͂
    ''===========================================================
    Public Sub PrintFooter()
        'Call Println("I :" & now())
        Call Println("End Date   :" & now())
        Call Println("--------------------------------------------------------------------------------------------------------")
    End Sub 
    
    
    ''===========================================================
    ''  name        : LogIniInfo
    ''  description : evpeB̐ݒlOo͂
    ''  param       : iniFileInfo   in      Ot@C̃IuWFNg
    ''===========================================================
    Public Sub PrintIniFileInfo(iniFileInfo)
        Call Println("Start Property List")
        Call Println("  SHOW_FOLDER_DIALOG                     =" & iniFileInfo.ShowFolderDialog)
        Call Println("  SHOW_FILE_NAME_DIALOG                  =" & iniFileInfo.ShowFileNameDialog)
        Call Println("  SHOW_MESSAGE_SUCCESS                   =" & iniFileInfo.ShowMessageSuccess)
        Call Println("  CREATE_ZIP                             =" & iniFileInfo.CreateZip)
        Call Println("  SHOW_MESSAGE_CREATE_ZIP                =" & iniFileInfo.ShowMessageCreateZip)
        Call Println("  OUTPUT_LOG                             =" & iniFileInfo.OutputLog)
        Call Println("  LOG_FOLDER_PATH                        =" & iniFileInfo.LogFolderPath)
        Call Println("  DEBUG_FLAG                             =" & iniFileInfo.DebugFlag)
        Call Println("  INPUT_INFO_FILE_PATH                   =" & iniFileInfo.InputInfoFilePath)
        Call Println("  OUTPUT_FOLDER_PATH                     =" & iniFileInfo.OutputFolderPath)
        Call Println("  COPY_OPTION_FILE                       =" & iniFileInfo.CopyOptionFile)
        Call Println("  XCOPY_OPTION_FOLDER                    =" & iniFileInfo.XcopyOptionFolder)
        Call Println("  SHELL_RUN_INT_WINDOW_TYPE_COPY_FILE    =" & iniFileInfo.ShellRunIntWindowTypeCopyFile)
        Call Println("  SHELL_RUN_INT_WINDOW_TYPE_COPY_FOLDER  =" & iniFileInfo.ShellRunIntWindowTypeCopyFolder)
        Call Println("  FORMAT                                 =" & iniFileInfo.Format)
        Call Println("  POSITION_BEFORE_EXTENSION              =" & iniFileInfo.PositionBeforeExtension)
        Call Println("End Property List")
    End Sub
    
    
End Class




''***********************************************************
'' 
'' obNAbvNX
'' 
''***********************************************************

Class Backup
    
    
    '------------------------------------------
    '  vpeB
    '------------------------------------------
    Private m_copyFromPath()                  'Rs[t@C̐΃pX̔z
    Private m_copyToPath()                    'Rs[t@C̐΃pX̔z
    
    Private m_log                             'O
    Private m_iniFileInfo                     'INIt@C
    Private m_cntProcess                      '
    
    
    '------------------------------------------
    '  RXgN^
    '------------------------------------------
    Private Sub Class_Initialize()
        
        Call Clear()
        
    End Sub
    
    
    '------------------------------------------
    '  fRXgN^
    '------------------------------------------
    Private Sub Class_Terminate()
        
        Call Clear()
        
    End Sub
    
    
    '------------------------------------------
    '  Getn֐
    '------------------------------------------
    Public Property Get CopyFromPath                :CopyFromPath           = m_copyFromPath         :End Property
    Public Property Get CopyToPath                  :CopyToPath             = m_copyToPath           :End Property
    Public Property Get CntProcess                  :CntProcess             = m_cntProcess           :End Property
    
    
    '------------------------------------------
    '  Letn֐
    '------------------------------------------
    Public Property Let Log                (value)  :Set m_log              = value                  :End Property
    Public Property Let IniFileInfo        (value)  :Set m_iniFileInfo      = value                  :End Property
    
    
    
    
    ''===========================================================
    ''  name        : Clear
    ''  description : 
    ''===========================================================
    Public Sub Clear()
        
        Redim Preserve m_copyFromPath(0)  :m_copyFromPath(0)  = ""
        Redim Preserve m_copyToPath(0)    :m_copyToPath(0)    = ""
        
        Set m_log                  = Nothing
        Set m_iniFileInfo          = Nothing
        
        m_cntProcess               = 0
        
    End Sub
    
    
    ''===========================================================
    ''  name        : Add
    ''  description : Rs[t@C̐΃pXǉ
    ''  param       : FromPath      in      Rs[t@C̐΃pX
    ''  return      : 
    ''===========================================================
    Public Sub Add(FromPath)
        
        If Len(Trim(FromPath)) = 0 Then
            Exit Sub
        End IF
        
        If IsExistFile(FromPath)   = False And _
           IsExistFolder(FromPath) = False Then
            Exit Sub
        End If
        
        Redim Preserve m_copyFromPath(UBound(m_copyFromPath)+1)
        m_copyFromPath(UBound(m_copyFromPath)) = FromPath
        
        
    End Sub
    
    
    ''===========================================================
    ''  name        : Start
    ''  description : obNAbvJn
    ''  param       : 
    ''  return      : True:I    False:ُI
    ''===========================================================
    Public Function Start()
        
        '------------------------------
        '[Jϐ
        '------------------------------
        
        'Rs[
        Dim copyFromName           't@C
        Dim copyFromFileName       'O
        Dim copyFromExt            'gq
        Dim isFile                 't@C
        Dim isFldr                 'tH_
        Dim isZip                  'ZIPt@C쐬
        
        'Rs[
        Dim copyToDirPath          'o͐tH_
        Dim fmt                    'tH[}bgϊ
        Dim copyToName             't@C
        Dim copyToPath             '΃pX
        
        Dim EMSG
        Dim RTN
        
        Const cEXT       = "."
        
        Start = False
        
        
        '̏
        m_cntProcess = 0
        
        
        'tH[}bgϊ
        fmt = m_iniFileInfo.Format
        fmt = GetTransformedFormat(fmt, EMSG)
        If Len(fmt) = 0 Then
            Call Println(EMSG)
            Exit Function
        End If
        
        
        'Rs[t@C̐΃pX̌AȉJԂ
        Dim i
        For i = 1 To UBound(m_copyFromPath)
            
            
            '̍XV
            m_cntProcess = m_cntProcess + 1
            
            
            '------------------------------
            'Rs[
            '------------------------------
            Call Println("CopyFromInfo[" & m_cntProcess & "] Path=" & m_copyFromPath(i))
            
            
            't@C
            isFile = IsExistFile(m_copyFromPath(i))
            isFldr = IsExistFolder(m_copyFromPath(i))
            Call Println("CopyFromInfo[" & m_cntProcess & "] Attribute isFile =" & isFile )
            Call Println("CopyFromInfo[" & m_cntProcess & "] Attribute isFldr =" & isFldr )
            
            
            't@C
            copyFromName     = Mid(m_copyFromPath(i), InstrRev(m_copyFromPath(i), "\") + 1)
            If isFile Then
                'Mod v1.03
                If InstrRev(copyFromName, cEXT) <> 0 Then
                    copyFromFileName = Left(copyFromName, (InstrRev(copyFromName, cEXT) - 1) )
                    copyFromExt      = Mid( copyFromName, (InstrRev(copyFromName, cEXT) + 1), Len(copyFromName))
                Else
                    copyFromFileName = copyFromName
                    copyFromExt      = ""
                End If
            End If
            Call Println("CopyFromInfo[" & m_cntProcess & "] Name=" & copyFromName)
            
            
            'ZIPt@C쐬
            isZip = False
            If m_iniFileInfo.CreateZip Then
                
                isZip = True
                
                If m_iniFileInfo.ShowMessageCreateZip Then
                    
                    EMSG = "Would you like to create ZIP file ?"
                    RTN = MsgBoxQuestion(EMSG)
                    If RTN = vbYes Then
                        isZip = True
                    Else
                        isZip = False
                    End If
                    
                End If
                
            End If
            Call Println("CopyFromInfo[" & m_cntProcess & "] Attribute isZip  =" & isZip)
            
            
            '------------------------------
            'Rs[
            '------------------------------
            'o͐tH_
            copyToDirPath = ""
            If Len(m_iniFileInfo.OutputFolderPath) > 0 Then
                copyToDirPath = m_iniFileInfo.OutputFolderPath
            Else
                copyToDirPath = Mid(m_copyFromPath(i), 1, InstrRev(m_copyFromPath(i), "\") - 1)
            End If
            
            
            'tH_Iʂo͐tH_I
            If m_iniFileInfo.ShowFolderDialog Then
                RTN = OpenFolderChooser(False, copyToDirPath, EMSG)
                If RTN <= 0 Then
                    Call Println(EMSG)
                    Exit Function
                End IF
            End If
            Call Println("CopyToInfo  [" & m_cntProcess & "] OutputFolderPath=" & copyToDirPath)
            
            
            't@C
            If isZip Then
                copyToName = copyFromName & cExt & fmt & ".zip"
                
            ElseIf isFile Then
                'copyToName = copyFromName & "." & fmt
                
                If m_iniFileInfo.PositionBeforeExtension Then
                    copyToName = copyFromFileName & fmt & cExt & copyFromExt
                Else
                    copyToName = copyFromName & cExt & fmt
                End If
                
            ElseIf isFldr Then
                copyToName = copyFromName & "_" & fmt
                
            End If
            
            
            '蓮Ńt@C͂
            If m_iniFileInfo.ShowFileNameDialog Then
                
                Dim mName
                mName = copyToName
                
                Do
                    mName = MsgBoxInput(mName)
                    
                    If IsEmpty(mName) Then
                        
                        Call MsgBoxInformation("It use default name(" & copyToName & ").", "")
                        mName = copyToName
                        
                    ElseIf Len(Trim(mName)) = 0 Then
                        
                        Call MsgBoxCheckInputData("Empty can not used for files and folders.")
                        mName = ""
                        
                    ElseIf isFldr And IsExistFoldr(copyToDirPath & "\" & mName) Then
                        
                        Call MsgBoxCheckInputData("It has already existed as folder name." & vbNewLine & copyToDirPath & "\" & mName)
                        mName = ""
                        
                    ElseIf IsExistFile(copyToDirPath & "\" & mName) Then
                        
                        Call MsgBoxCheckInputData("It has already existed as file name." & vbNewLine & copyToDirPath & "\" & mName)
                        mName = ""
                        
                    End If
                    
                Loop While Len(Trim(mName)) = 0
                
                copyToName = mName
                
            End If
            Call Println("CopyToInfo  [" & m_cntProcess & "] Name=" & copyToName)
            
            '΃pX
            Redim Preserve m_copyToPath(i)
            m_copyToPath(i) = ""
            
            If isZip Then
                'Mod v1.03
                'm_copyToPath(i) = copyToDirPath & "\" & copyToName & cExt & "zip"
                m_copyToPath(i) = copyToDirPath & "\" & copyToName
            ElseIf isFile Then
                m_copyToPath(i) = copyToDirPath & "\" & copyToName
            ElseIf isFldr Then
                m_copyToPath(i) = copyToDirPath & "\" & copyToName
            End If
            Call Println("CopyToInfo  [" & m_cntProcess & "] Path=" & m_copyToPath(i))
            
            
            '------------------------------
            'obNAbv̐
            '------------------------------
            Call Println("Backup      [" & m_cntProcess & "] Start Process for Creation")
            
            RTN = 1
            If isZip Then
                RTN = CreateZip(  m_copyFromPath(i), m_copyToPath(i) )
            ElseIf isFile Then
                RTN = CopyFile(   m_copyFromPath(i), m_copyToPath(i) )
            ElseIf isFldr Then
                RTN = CopyFolder( m_copyFromPath(i), m_copyToPath(i) )
            End If
            
            Call Println("Backup      [" & m_cntProcess & "] End Process for Creation")
            Call Println("---")
            
            
        Next
        
        
        Start = True
        
        
    End Function
    
    ''===========================================================
    ''  name        : CopyFile
    ''  description : t@CRs[
    ''  param       : FromPath      in      Rs[t@C̐΃pX
    ''              : ToPath        in      Rs[t@C̐΃pX
    ''  return      : True:I    False:ُI
    ''===========================================================
    Private Function CopyFile(FromPath, ToPath)
        
        CopyFile = False
        
        Dim RTN
        Dim SH
        
        Set SH = WScript.CreateObject("WScript.Shell")
        
        RTN = SH.Run( "cmd.exe /c COPY " & m_iniFileInfo.CopyOptionFile &  " """ & FromPath & """ """ & ToPath & """", _
                       m_iniFileInfo.ShellRunIntWindowTypeCopyFile, _
                       True )
        
        If RTN = 1 Then
            CopyFile = True
        End If
        
        Set SH = Nothing
        
    End Function
    
    
    ''===========================================================
    ''  name        : CopyFolder
    ''  description : tH_Rs[
    ''  param       : FromPath      in      Rs[tH_̐΃pX
    ''              : ToPath        in      Rs[tH_̐΃pX
    ''  return      : 1:I    1ȊO:ُI
    ''===========================================================
    Private Function CopyFolder(FromPath, ToPath)
        
        CopyFolder = False
        
        Dim RTN
        Dim SH
        
        Set SH = WScript.CreateObject("WScript.Shell")
        
        RTN = SH.Run( "XCOPY """ & FromPath & """ """ & ToPath & """ " & m_iniFileInfo.XcopyOptionFolder, _
                       m_iniFileInfo.ShellRunIntWindowTypeCopyFolder, _
                       True )
        
        If RTN = 1 Then
            CopyFolder = True
        End If
        
        Set SH = Nothing
        
    End Function
    
    
    ''===========================================================
    ''  name        : CreateZip
    ''  description : ZIPt@C쐬
    ''  param       : copyFromPath  in      Rs[tH_̐΃pX
    ''              : copyToPath    in      Rs[t@C̐΃pX
    ''  return      : True:I    False:ُI
    ''===========================================================
    Private Function CreateZip(copyFromPath, copyToPath)
        
        CreateZip = False
        
        If m_iniFileInfo.CreateZip = False Then
            Exit Function
        End If
        
        Dim FS :Set FS = CreateObject("Scripting.FileSystemObject")
        Dim SA :Set SA = CreateObject("Shell.Application")
        
        'zipt@C쐬āAʎq
        With FS.CreateTextFile(copyToPath)
            .Write "PK" & Chr(5) & Chr(6) & String(18,0)
            .Close
        End With
        
        'zipt@Cւ̏
        With SA.NameSpace(copyToPath)
            .CopyHere copyFromPath
        End With
        
        'Add v01.04 r`FbN
        Do Until isFileLock(copyToPath) :Loop
        
        WScript.sleep 1000
        
        Set FS = Nothing
        Set SA = Nothing
        
        CreateZip = True
        
    End Function
    
    
    ''===========================================================
    ''  name        : isFileLock
    ''  description : t@Cr䂳Ă邩肷
    ''  param       : path          in      t@C̐΃pX
    ''  return      : True:r䂠    False:rȂ
    ''===========================================================
    Private Function isFileLock(path)
        
        isFileLock = False
        
        On Error Resume Next
        
        Dim FS :Set FS = CreateObject("Scripting.FileSystemObject")
        Dim md :md = 8  'Appending
        
        WScript.Sleep 1000
        
        'ǋL[hŃt@CJ
        FS.OpenTextFile(path, md, False).Close
        
        'r䒆̏ꍇ̓G[Ƃ
        If Err.Number = 0 Then
            isFileLock = True
        End If
        
        Set FS = Nothing
        
        On Error GoTo 0
        
    End Function
    
    
    ''===========================================================
    ''  name        : Println
    ''  description : Oo͂B
    ''  param       : MSG           in      bZ[W
    ''===========================================================
    Private Sub Println(MSG)
        If m_log Is Nothing Then
            Exit Sub
        End If
        m_log.Println(MSG)
    End Sub
    
    
    
    ''===========================================================
    ''  name        : GetYYMMDD
    ''  description : ̕(YYYYMMDD_HHMISS)Ԃ
    ''  
    ''===========================================================
    Private Function GetYYYYMMDD_HHMISS()
        
        Dim tm    :tm   = now()
        
        Dim YYYY  :YYYY = Year(tm)
        Dim MM    :MM   = Right("0" & Month(tm) , 2)
        Dim DD    :DD   = Right("0" & Day(tm)   , 2)
        Dim HH    :HH   = Right("0" & Hour(tm)  , 2)
        Dim MI    :MI   = Right("0" & Minute(tm), 2)
        Dim SS    :SS   = Right("0" & Second(tm), 2)
        
        GetYYYYMMDD_HHMISS = YYYY & MM & DD & "_" & HH & MI & SS
        
    End Function
    
    
    ''===========================================================
    ''  name        : GetTransformedFormat
    ''  description : tH[}bgϊԂ
    ''  param       : fmt           in      tH[}bg
    ''              : EMSG          out     G[bZ[W
    ''===========================================================
    Private Function GetTransformedFormat(fmt, EMSG)
        
        Dim dosFileName          'DOSt@C̖O
        Dim dosFldrPath          'DOSt@CzutH_̐΃pX
        Dim dosFilePath          'DOSt@C̐΃pX
        
        Dim txtFileName          'TXTt@C̖O
        Dim txtFldrPath          'TXTt@CzutH_̐΃pX
        Dim txtFilePath          'TXTt@C̐΃pX
        
        Dim SHL                  'VFIuWFNg
        Dim FSO                  't@CVXeIuWFNg
        Dim F                    't@CIuWFNg
        
        Dim cmd                  'R}h
        Dim rtn                  '߂l
        Dim tfmt                 'ϊtH[}bg
        
        
        '------------------------------------------
        '  DOSt@C
        '------------------------------------------
        dosFileName = "Format.bat"
        dosFldrPath = Left(WScript.ScriptFullName, Len(WScript.ScriptFullName) - Len(WScript.ScriptName) )
        dosFilePath = dosFldrPath & dosFileName
        
        
        '------------------------------------------
        '  R}h̍쐬
        '------------------------------------------
        cmd  = """" & dosFilePath & """" & " " & fmt
        
        
        '------------------------------------------
        '  tH[}bg̎擾
        '------------------------------------------
        Set SHL = CreateObject("WScript.Shell")
        SHL.CurrentDirectory = dosFldrPath
        rtn = SHL.Run(cmd, 0, True)
        Set SHL = Nothing
        If rtn <> 0 Then
            EMSG = "Error was occurred when it got the format. rtn=" & rtn
            Exit Function
        End If
        
        
        '------------------------------------------
        '  TXTt@C
        '------------------------------------------
        txtFileName = "FORMAT_RESULT.txt"
        txtFldrPath = Left(WScript.ScriptFullName, Len(WScript.ScriptFullName) - Len(WScript.ScriptName) )
        txtFilePath = txtFldrPath & txtFileName
        
        
        '------------------------------
        ' t@C̃I[v
        '------------------------------
        Set FSO = WScript.CreateObject("Scripting.FileSystemObject")
        Set F   = FSO.OpenTextFile(txtFilePath)
        
        Do While F.AtEndOfStream <> True
            tfmt = Trim(F.ReadLine)
        Loop
        F.Close
        
        FSO.DeleteFile txtFilePath
        
        Set F   = Nothing
        Set FSO = Nothing
        
        
        GetTransformedFormat = tfmt
        
    End Function
    
    
    ''===========================================================
    ''  name        : OpenFolderChooser
    ''  description : tH_Iʂ\
    ''  param       : IsCreate      in      VKtH_̍쐬(True:쐬AFalse:쐬s)
    ''              : FolderPath    out     IꂽtH_̐΃pX
    ''              : EMSG          out     bZ[W
    ''===========================================================
    Private Function OpenFolderChooser(IsCreate, FolderPath, EMSG)
        
        EMSG = ""
        
        '------------------------------
        'tH_Iʂ̕\
        '------------------------------
        Dim Shll
        Set Shll = CreateObject("Shell.Application")
        
        Dim Attr
        If IsCreate Then
            Attr = &h0100    'VK쐬{^
        Else
            Attr = &h0200    'VK쐬{^Ȃ
        End If
        
        Dim Fldr
        Set Fldr = Shll.BrowseForFolder(0, "Select Folder.", Attr)
        
        
        '------------------------------
        'tH_I
        '------------------------------
        If (Fldr Is Nothing) Then
            EMSG = "Cancel button was clicked."
            FolderPath = ""
            OpenFolderChooser = 0
            
        ElseIf Not Fldr.Self.IsFileSystem then
            EMSG = "It dose not exist on file system F" & Fldr.Self.Name
            FolderPath = ""
            OpenFolderChooser = -1
            
        Else
            EMSG = ""
            FolderPath = Fldr.Self.Path
            OpenFolderChooser = 1
            
        End If
        
        Set Fldr = Nothing
        Set Shll = Nothing
        
    End Function
    
    

    ''===========================================================
    ''  name        : SetInputFilePath
    ''  description : ̓t@C΃pXݒ肷
    ''  param       : filePath      in      ̓t@C̐΃pX
    ''===========================================================
    Public Sub SetInputFilePath(filePath)
        
        
        '------------------------------
        ' t@C̃I[v
        '------------------------------
        Dim fs   :Set fs = CreateObject("Scripting.FileSystemObject")
        'Mod v01.03
        'Dim f    :Set f  = fs.OpenTextFile(path)
        Dim f    :Set f  = fs.OpenTextFile(filePath)
        
        
        '------------------------------
        ' sPʂ̓ǂݍ
        '------------------------------
        Dim s
        Do While f.AtEndOfStream <> True
            
            s = Trim(f.ReadLine)
            
            If Len(s) > 0 And ( IsExistFile(s) = False And IsExistFolder(s) = False ) = False Then
                
                Redim Preserve m_copyFromPath( UBound(m_copyFromPath) )
                
                m_copyFromPath(UBound(m_copyFromPath)) = s
                
            End If
        Loop
        
        
        '------------------------------
        ' t@C̃N[Y
        '------------------------------
        f.Close
        
        Set f  = Nothing
        Set fs = Nothing
        
        
    End Sub
    
    
End Class




''===========================================================
''  name        : MAIN
''  description : C
''  param       : 
''===========================================================
Sub MAIN()
    
    Dim wk_INI           'init@C
    Dim wk_LOG           'O
    Dim wk_BK            'obNAbv
    
    Dim EMSG             'G[bZ[W
    Dim RTN              '߂l
    Dim I
    
    
    '------------------------------
    ' init@C̎擾
    '------------------------------
    Set wk_INI = New IniFileInfo
    RTN = wk_INI.Read(EMSG)
    If RTN = False Then
        Call MsgBoxError(EMSG)
        Set wk_INI  = Nothing
        WScript.Quit
    End If
    
    
    '------------------------------
    ' O
    '------------------------------
    Set wk_LOG           = New Log2
    wk_LOG.OutputLog     = wk_INI.OutputLog              'Oo͂̐ݒ
    wk_LOG.LogFolderPath = wk_INI.LogFolderPath          'Oo͐tH_̐ݒ
    
    
    '------------------------------
    ' `FbN
    '------------------------------
    'Mod v1.03
    'If WScript.Arguments.Unnamed.Count = 0 Then
    If WScript.Arguments.Unnamed.Count = 0 And _
         Len(wk_INI.InputInfoFilePath) = 0 Then
        
        Call MsgBoxCopyright
        Set wk_LOG  = Nothing
        Set wk_INI  = Nothing
        WScript.Quit
        
    ElseIf WScript.Arguments.Unnamed.Count > 0 And _
           Len(wk_INI.InputInfoFilePath)   = 0 Then
        
        Select Case UCASE( TRIM( WScript.Arguments(0) ) )
            
            Case "-H"
                Call MsgHelp
                Set wk_LOG  = Nothing
                Set wk_INI  = Nothing
                WScript.Quit
                
            Case "-V"
                Call MsgBoxCopyright
                Set wk_LOG  = Nothing
                Set wk_INI  = Nothing
                WScript.Quit
                
            Case "-VERSION"
                Call MsgBoxCopyright
                Set wk_LOG  = Nothing
                Set wk_INI  = Nothing
                WScript.Quit
                
        End Select
        
    End If
    
    
    '------------------------------
    ' obNAbv̐ݒ
    '------------------------------
    Set wk_BK = New Backup
    
    wk_LOG.Open()                                        'Ot@C̃I[v
    wk_LOG.PrintHeader()                                 'wb_[̏o
    wk_LOG.PrintIniFileInfo(wk_INI)                      'init@C̏o
    
    wk_BK.Log            = wk_LOG                        'Ot@C̐ݒ
    wk_BK.IniFileInfo    = wk_INI                        'init@C̐ݒ
    
    
    '------------------------------
    ' Rs[t@C̐ݒ
    '------------------------------
    If Len(wk_INI.InputInfoFilePath) > 0 Then
        
        'Mod v1.03
        I = 1
        wk_LOG.Println("PARAM       [" & I & "] " & wk_INI.InputInfoFilePath)
        wk_BK.Add wk_INI.InputInfoFilePath
        
    Else
        
        For I = 0 To WScript.Arguments.Unnamed.Count - 1
            wk_LOG.Println("PARAM       [" & I & "] " & WScript.Arguments.Unnamed(I))
            wk_BK.Add WScript.Arguments.Unnamed(I)
        Next
        
    End If
    
    
    '------------------------------
    ' obNAbv
    '------------------------------
    RTN = wk_BK.Start()
    
    wk_LOG.Println("Backup Process Count :" & wk_BK.CntProcess)
    If RTN Then
        wk_LOG.Println("Backup Success")
    Else
        wk_LOG.Println("Backup Fault")
    End If
    
    
    wk_LOG.PrintFooter()                                 'tb^[̏o
    wk_LOG.Close()                                       'Ot@C̃N[Y
    
    
    '------------------------------
    ' bZ[W
    '------------------------------
    If wk_INI.ShowMessageSuccess Then
        
        If RTN Then
            Call MsgBoxSuccess
        Else
            Call MsgBoxFault
        End IF
        
    End If
    
    
    Set wk_BK   = Nothing
    Set wk_LOG  = Nothing
    Set wk_INI  = Nothing
    
    
End Sub


Call Main()


